//############################################################################
// ~ International Laser Display Association ~
// ~     ILDA file format driver in C++      ~
// ~             built for EZFB              ~
//
// by James Lehman
// Extra Stimulus Inc.
// james@akrobiz.com
//
// began: October 2003
//
//############################################################################
#include "ez_ilda.hpp"
    
//############################################################################
void undo_wave_temp(ifstream &in, ofstream &out, string file_name)
{
    if(in.is_open())
        in.close();
    if(out.is_open())
        out.close();
    remove((EZ_ILDA_WAVE_SHARE + file_name).c_str());
    rename(  (EZ_ILDA_WAVE_SHARE + "__TEMP__.wav").c_str()
           , (EZ_ILDA_WAVE_SHARE + file_name).c_str()
          );        
    return;
}

//############################################################################
int distance_points(const ez_ilda_point p1, const ez_ilda_point p2)
{
    return (int)(ceil((p1 | p2) / ez_ilda_pointer->distance_delta_max));
}

//############################################################################
int dwell_points(double angle) // zero to pi radians
{
    return (int)(ceil(    angle / pi // zero to one
                       * (    ez_ilda_pointer->wave_sample_rate
                           * (ez_ilda_pointer->longest_dwell_microsec / 1000000.0)
                         )
                     )
                );
}

//############################################################################
u_int next_hue()
{
    static int i = 0;    
    switch(i++ % 12)
    {
        case 0:
            return BMP.make_rgb(255,0,0);
        case 1:
            return BMP.make_rgb(255,128,0);
        case 2:
            return BMP.make_rgb(255,255,0);
        case 3:
            return BMP.make_rgb(128,255,0);
        case 4:
            return BMP.make_rgb(0,255,0);
        case 5:
            return BMP.make_rgb(0,255,128);
        case 6:
            return BMP.make_rgb(0,255,255);
        case 7:
            return BMP.make_rgb(0,128,255);
        case 8:
            return BMP.make_rgb(0,0,255);
        case 9:
            return BMP.make_rgb(128,0,255);
        case 10:
            return BMP.make_rgb(255,0,255);
        case 11:
            return BMP.make_rgb(255,0,128);
    }
    return 0;
}

//############################################################################
//////////////////////////////////////////////////////////////////////////////
//############################################################################
